/**
 * generated by Xtext 2.15.0
 */
package org.sif.dsl.tests;

import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.extensions.InjectionExtension;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.sif.dsl.sat.And;
import org.sif.dsl.sat.Biimplies;
import org.sif.dsl.sat.Excludes;
import org.sif.dsl.sat.Formula;
import org.sif.dsl.sat.Implies;
import org.sif.dsl.sat.Not;
import org.sif.dsl.sat.Or;
import org.sif.dsl.sat.PFormula;
import org.sif.dsl.sat.Start;
import org.sif.dsl.tests.SatInjectorProvider;

@ExtendWith(InjectionExtension.class)
@InjectWith(SatInjectorProvider.class)
@SuppressWarnings("all")
public class SatParsingTest {
  @Inject
  private ParseHelper<Start> parseHelper;
  
  @Test
  public void complexParsing() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A and B => (C or A) <=> D and (~B nand C) using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseBiimplies() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A <=> B using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof Biimplies));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseImplies() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A => B using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof Implies));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseOr() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A or B using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof Or));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseExcludes() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A nand B using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof Excludes));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseAnd() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check A and B using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof And));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseNot() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check ~A using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof Not));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parsePFormula() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Check (A) using SAT4J;");
      _builder.newLine();
      final Start result = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
      Formula _formula = result.getChecks().get(0).getFormula();
      Assertions.assertTrue((_formula instanceof PFormula));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void test() {
  }
}
